Make "index_name_exists()" return the cache_entry it found
[git/dscho.git] / git-submodule.sh
blob56ec3536e0c40190329b9867b46e36753f30efb2
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE="[--quiet] [--cached] \
8 [add <repo> [-b branch]|status|init|update|summary [-n|--summary-limit <n>] [<commit>]] \
9 [--] [<path>...]"
10 OPTIONS_SPEC=
11 . git-sh-setup
12 require_work_tree
14 command=
15 branch=
16 quiet=
17 cached=
20 # print stuff on stdout unless -q was specified
22 say()
24 if test -z "$quiet"
25 then
26 echo "$@"
30 # NEEDSWORK: identical function exists in get_repo_base in clone.sh
31 get_repo_base() {
33 cd "`/bin/pwd`" &&
34 cd "$1" || cd "$1.git" &&
36 cd .git
37 pwd
39 ) 2>/dev/null
42 # Resolve relative url by appending to parent's url
43 resolve_relative_url ()
45 branch="$(git symbolic-ref HEAD 2>/dev/null)"
46 remote="$(git config branch.${branch#refs/heads/}.remote)"
47 remote="${remote:-origin}"
48 remoteurl="$(git config remote.$remote.url)" ||
49 die "remote ($remote) does not have a url in .git/config"
50 url="$1"
51 while test -n "$url"
53 case "$url" in
54 ../*)
55 url="${url#../}"
56 remoteurl="${remoteurl%/*}"
58 ./*)
59 url="${url#./}"
62 break;;
63 esac
64 done
65 echo "$remoteurl/$url"
69 # Map submodule path to submodule name
71 # $1 = path
73 module_name()
75 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
76 re=$(printf '%s' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
77 name=$( GIT_CONFIG=.gitmodules \
78 git config --get-regexp '^submodule\..*\.path$' |
79 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
80 test -z "$name" &&
81 die "No submodule mapping found in .gitmodules for path '$path'"
82 echo "$name"
86 # Clone a submodule
88 # Prior to calling, cmd_update checks that a possibly existing
89 # path is not a git repository.
90 # Likewise, cmd_add checks that path does not exist at all,
91 # since it is the location of a new submodule.
93 module_clone()
95 path=$1
96 url=$2
98 # If there already is a directory at the submodule path,
99 # expect it to be empty (since that is the default checkout
100 # action) and try to remove it.
101 # Note: if $path is a symlink to a directory the test will
102 # succeed but the rmdir will fail. We might want to fix this.
103 if test -d "$path"
104 then
105 rmdir "$path" 2>/dev/null ||
106 die "Directory '$path' exist, but is neither empty nor a git repository"
109 test -e "$path" &&
110 die "A file already exist at path '$path'"
112 git-clone -n "$url" "$path" ||
113 die "Clone of '$url' into submodule path '$path' failed"
117 # Add a new submodule to the working tree, .gitmodules and the index
119 # $@ = repo [path]
121 # optional branch is stored in global branch variable
123 cmd_add()
125 # parse $args after "submodule ... add".
126 while test $# -ne 0
128 case "$1" in
129 -b | --branch)
130 case "$2" in '') usage ;; esac
131 branch=$2
132 shift
134 -q|--quiet)
135 quiet=1
138 shift
139 break
142 usage
145 break
147 esac
148 shift
149 done
151 repo=$1
152 path=$2
154 if test -z "$repo"; then
155 usage
158 # Guess path from repo if not specified or strip trailing slashes
159 if test -z "$path"; then
160 path=$(echo "$repo" | sed -e 's|/*$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
161 else
162 path=$(echo "$path" | sed -e 's|/*$||')
165 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
166 die "'$path' already exists in the index"
168 # perhaps the path exists and is already a git repo, else clone it
169 if test -e "$path"
170 then
171 if test -d "$path/.git" &&
172 test "$(unset GIT_DIR; cd $path; git rev-parse --git-dir)" = ".git"
173 then
174 echo "Adding existing repo at '$path' to the index"
175 else
176 die "'$path' already exists and is not a valid git repo"
178 else
179 case "$repo" in
180 ./*|../*)
181 # dereference source url relative to parent's url
182 realrepo="$(resolve_relative_url $repo)" ;;
184 # Turn the source into an absolute path if
185 # it is local
186 if base=$(get_repo_base "$repo"); then
187 repo="$base"
189 realrepo=$repo
191 esac
193 module_clone "$path" "$realrepo" || exit
194 (unset GIT_DIR; cd "$path" && git checkout -q ${branch:+-b "$branch" "origin/$branch"}) ||
195 die "Unable to checkout submodule '$path'"
198 git add "$path" ||
199 die "Failed to add submodule '$path'"
201 GIT_CONFIG=.gitmodules git config submodule."$path".path "$path" &&
202 GIT_CONFIG=.gitmodules git config submodule."$path".url "$repo" &&
203 git add .gitmodules ||
204 die "Failed to register submodule '$path'"
208 # Register submodules in .git/config
210 # $@ = requested paths (default to all)
212 cmd_init()
214 # parse $args after "submodule ... init".
215 while test $# -ne 0
217 case "$1" in
218 -q|--quiet)
219 quiet=1
222 shift
223 break
226 usage
229 break
231 esac
232 shift
233 done
235 git ls-files --stage -- "$@" | grep '^160000 ' |
236 while read mode sha1 stage path
238 # Skip already registered paths
239 name=$(module_name "$path") || exit
240 url=$(git config submodule."$name".url)
241 test -z "$url" || continue
243 url=$(GIT_CONFIG=.gitmodules git config submodule."$name".url)
244 test -z "$url" &&
245 die "No url found for submodule path '$path' in .gitmodules"
247 # Possibly a url relative to parent
248 case "$url" in
249 ./*|../*)
250 url="$(resolve_relative_url "$url")"
252 esac
254 git config submodule."$name".url "$url" ||
255 die "Failed to register url for submodule path '$path'"
257 say "Submodule '$name' ($url) registered for path '$path'"
258 done
262 # Update each submodule path to correct revision, using clone and checkout as needed
264 # $@ = requested paths (default to all)
266 cmd_update()
268 # parse $args after "submodule ... update".
269 while test $# -ne 0
271 case "$1" in
272 -q|--quiet)
273 quiet=1
276 shift
277 break
280 usage
283 break
285 esac
286 shift
287 done
289 git ls-files --stage -- "$@" | grep '^160000 ' |
290 while read mode sha1 stage path
292 name=$(module_name "$path") || exit
293 url=$(git config submodule."$name".url)
294 if test -z "$url"
295 then
296 # Only mention uninitialized submodules when its
297 # path have been specified
298 test "$#" != "0" &&
299 say "Submodule path '$path' not initialized"
300 continue
303 if ! test -d "$path"/.git
304 then
305 module_clone "$path" "$url" || exit
306 subsha1=
307 else
308 subsha1=$(unset GIT_DIR; cd "$path" &&
309 git rev-parse --verify HEAD) ||
310 die "Unable to find current revision in submodule path '$path'"
313 if test "$subsha1" != "$sha1"
314 then
315 (unset GIT_DIR; cd "$path" && git-fetch &&
316 git-checkout -q "$sha1") ||
317 die "Unable to checkout '$sha1' in submodule path '$path'"
319 say "Submodule path '$path': checked out '$sha1'"
321 done
324 set_name_rev () {
325 revname=$( (
326 unset GIT_DIR
327 cd "$1" && {
328 git describe "$2" 2>/dev/null ||
329 git describe --tags "$2" 2>/dev/null ||
330 git describe --contains --tags "$2"
333 test -z "$revname" || revname=" ($revname)"
336 # Show commit summary for submodules in index or working tree
338 # If '--cached' is given, show summary between index and given commit,
339 # or between working tree and given commit
341 # $@ = [commit (default 'HEAD'),] requested paths (default all)
343 cmd_summary() {
344 summary_limit=-1
346 # parse $args after "submodule ... summary".
347 while test $# -ne 0
349 case "$1" in
350 --cached)
351 cached="$1"
353 -n|--summary-limit)
354 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
355 then
357 else
358 usage
360 shift
363 shift
364 break
367 usage
370 break
372 esac
373 shift
374 done
376 test $summary_limit = 0 && return
378 if rev=$(git rev-parse --verify "$1^0" 2>/dev/null)
379 then
380 head=$rev
381 shift
382 else
383 head=HEAD
386 cd_to_toplevel
387 # Get modified modules cared by user
388 modules=$(git diff-index $cached --raw $head -- "$@" |
389 grep -e '^:160000' -e '^:[0-7]* 160000' |
390 while read mod_src mod_dst sha1_src sha1_dst status name
392 # Always show modules deleted or type-changed (blob<->module)
393 test $status = D -o $status = T && echo "$name" && continue
394 # Also show added or modified modules which are checked out
395 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
396 echo "$name"
397 done
400 test -n "$modules" &&
401 git diff-index $cached --raw $head -- $modules |
402 grep -e '^:160000' -e '^:[0-7]* 160000' |
403 cut -c2- |
404 while read mod_src mod_dst sha1_src sha1_dst status name
406 if test -z "$cached" &&
407 test $sha1_dst = 0000000000000000000000000000000000000000
408 then
409 case "$mod_dst" in
410 160000)
411 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
413 100644 | 100755 | 120000)
414 sha1_dst=$(git hash-object $name)
416 000000)
417 ;; # removed
419 # unexpected type
420 echo >&2 "unexpected mode $mod_dst"
421 continue ;;
422 esac
424 missing_src=
425 missing_dst=
427 test $mod_src = 160000 &&
428 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_src^0 >/dev/null 2>&1 &&
429 missing_src=t
431 test $mod_dst = 160000 &&
432 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_dst^0 >/dev/null 2>&1 &&
433 missing_dst=t
435 total_commits=
436 case "$missing_src,$missing_dst" in
438 errmsg=" Warn: $name doesn't contain commit $sha1_src"
441 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
443 t,t)
444 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
447 errmsg=
448 total_commits=$(
449 if test $mod_src = 160000 -a $mod_dst = 160000
450 then
451 range="$sha1_src...$sha1_dst"
452 elif test $mod_src = 160000
453 then
454 range=$sha1_src
455 else
456 range=$sha1_dst
458 GIT_DIR="$name/.git" \
459 git log --pretty=oneline --first-parent $range | wc -l
461 total_commits=" ($(($total_commits + 0)))"
463 esac
465 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
466 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
467 if test $status = T
468 then
469 if test $mod_dst = 160000
470 then
471 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
472 else
473 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
475 else
476 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
478 if test -n "$errmsg"
479 then
480 # Don't give error msg for modification whose dst is not submodule
481 # i.e. deleted or changed to blob
482 test $mod_dst = 160000 && echo "$errmsg"
483 else
484 if test $mod_src = 160000 -a $mod_dst = 160000
485 then
486 limit=
487 test $summary_limit -gt 0 && limit="-$summary_limit"
488 GIT_DIR="$name/.git" \
489 git log $limit --pretty='format: %m %s' \
490 --first-parent $sha1_src...$sha1_dst
491 elif test $mod_dst = 160000
492 then
493 GIT_DIR="$name/.git" \
494 git log --pretty='format: > %s' -1 $sha1_dst
495 else
496 GIT_DIR="$name/.git" \
497 git log --pretty='format: < %s' -1 $sha1_src
499 echo
501 echo
502 done
505 # List all submodules, prefixed with:
506 # - submodule not initialized
507 # + different revision checked out
509 # If --cached was specified the revision in the index will be printed
510 # instead of the currently checked out revision.
512 # $@ = requested paths (default to all)
514 cmd_status()
516 # parse $args after "submodule ... status".
517 while test $# -ne 0
519 case "$1" in
520 -q|--quiet)
521 quiet=1
523 --cached)
524 cached=1
527 shift
528 break
531 usage
534 break
536 esac
537 shift
538 done
540 git ls-files --stage -- "$@" | grep '^160000 ' |
541 while read mode sha1 stage path
543 name=$(module_name "$path") || exit
544 url=$(git config submodule."$name".url)
545 if test -z "$url" || ! test -d "$path"/.git
546 then
547 say "-$sha1 $path"
548 continue;
550 set_name_rev "$path" "$sha1"
551 if git diff-files --quiet -- "$path"
552 then
553 say " $sha1 $path$revname"
554 else
555 if test -z "$cached"
556 then
557 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
558 set_name_rev "$path" "$sha1"
560 say "+$sha1 $path$revname"
562 done
565 # This loop parses the command line arguments to find the
566 # subcommand name to dispatch. Parsing of the subcommand specific
567 # options are primarily done by the subcommand implementations.
568 # Subcommand specific options such as --branch and --cached are
569 # parsed here as well, for backward compatibility.
571 while test $# != 0 && test -z "$command"
573 case "$1" in
574 add | init | update | status | summary)
575 command=$1
577 -q|--quiet)
578 quiet=1
580 -b|--branch)
581 case "$2" in
583 usage
585 esac
586 branch="$2"; shift
588 --cached)
589 cached="$1"
592 break
595 usage
598 break
600 esac
601 shift
602 done
604 # No command word defaults to "status"
605 test -n "$command" || command=status
607 # "-b branch" is accepted only by "add"
608 if test -n "$branch" && test "$command" != add
609 then
610 usage
613 # "--cached" is accepted only by "status" and "summary"
614 if test -n "$cached" && test "$command" != status -a "$command" != summary
615 then
616 usage
619 "cmd_$command" "$@"